﻿<AML>
 <Item type="Method" id="50C7075B765B4EEEA9534A2B074836D9" action="add">
  <execution_allowed_to keyed_name="World" type="Identity">A73B655731924CD0B027E4F4D5FCC0A9</execution_allowed_to>
  <method_code><![CDATA[            /* *****************************************************************************
            Method Name:			acc_sale_bill_approve
            Created By/Company:		SolidCAD 
            Creation Date:			2018-01-23
            Description:
                -Update staus of Sale Invoice.
                -If Classification is Service,attach PDF for Service.
                -If Classification is Equipment,attach PDF for Equipment.

            Hooks:
                Type:		Life Cycle Map : acc_sale_LC
                Event:		Server Methods ( Pre )
                
            Revisions:
                Rev Date		Modified By			Description
                YYYY-MM-DD		***					Initial creation
            ***************************************************************************** */

            //WARNING: DO NOT FORGET TO DISABLE THIS IN A PRODUCTION ENVIRONMENT!!!
            //if(System.Diagnostics.Debugger.Launch()) System.Diagnostics.Debugger.Break();

            string MethodName = "acc_sale_bill_approve";

            //***** GRANT IDENTITY PRIVILEGES
            // grantIdentityPrivileges("Super User"); // If this is enabled always revoke the privileges in the Finally below.
            //*******************************
            Innovator myInnovator = this.getInnovator();
            Item result = this; // default return value.

            try
            {
                var _id = this.getID();
                string invoice_number = this.getProperty("sop_invoice_no", "");
                string classification = this.getProperty("classification", "");

                var update_query = "UPDATE innovator.[sop_sale_invoice]" +
                        "SET pop_invoice_status='Approved' " +
                        " WHERE id='" + _id + "'";
                Item sop_sale_invoice_update = myInnovator.applySQL(update_query);

                if (sop_sale_invoice_update.isError())
                    return myInnovator.newError("Error in updating sale invoice.");

                if (classification.ToUpper() == "SERVICE")
                {
                    var result_sop_service_pdf = myInnovator.applyMethod("sop_service_pdf", "<id>" + _id + "</id><invoice_number>" + invoice_number + "</invoice_number>");
                    if (result_sop_service_pdf.isError())
                        return myInnovator.newError("Error in attach Tax Invoice PDF.");

                    var result1 = myInnovator.applyMethod("sop_service_part_pdf", "<id>" + _id + "</id><invoice_number>" + invoice_number + "</invoice_number>");
                    if (result1.isError())
                        return myInnovator.newError("Error in attach Tax Invoice PDF.");
                }

                else
                {
                    var result_sop_Tax_invoice_pdf = myInnovator.applyMethod("sop_Tax_invoice_pdf", "<id>" + _id + "</id><invoice_number>" + invoice_number + "</invoice_number>");
                    if (result_sop_Tax_invoice_pdf.isError())
                        return myInnovator.newError("Error in attach Tax Invoice PDF.");
                }
            }
            catch (System.Exception ex)
            {
                result = myInnovator.newError(string.Format("SYSTEM EXCEPTION in method {0}\n{1}", MethodName, ex.Message));
                ////result.setErrorCode("0");		//only use if this method is called from another method
            }
            finally
            {
                //**** REVOKE IDENTITY PRIVILEGES
                // revokeIdentityPrivileges();
                //*******************************
            }

            return result;
        }
        /// <summary>
        /// This section is to allow the current method to assume the privileges of a specific identity.
        /// For instance calling: grantIdentityPrivileges("Aras PLM"); will allow this method all of the
        /// rights of the Aras PLM identity.
        /// The revokeIdentityPrivileges() method will removed the privileges added for this method. It
        /// must be called from before the method exits. Most likely in the Finally of the main method code.
        /// If different identity privileges must be granted a second time within the same method, first use
        /// revokeIdentityPrivileges() to remove the first privileges before granting new ones.
        /// </summary>

        private string AssignedIdentity;

        /// <summary>
        /// If required, call this helper function to run this method as another Identity. 
        /// Ensure that you call the revokeIdentityPrivileges helper function in the 
        /// finally block to revoke the Identity privilege when this method completes.
        /// </summary>
        public void grantIdentityPrivileges(string assignedIdent)
        {
            if (!string.IsNullOrEmpty(AssignedIdentity))
            {
                revokeIdentityPrivileges();
            }

            Aras.Server.Security.Identity secIdentity = Aras.Server.Security.Identity.GetByName(assignedIdent);
            if (Aras.Server.Security.Permissions.GrantIdentity(secIdentity))
            {
                AssignedIdentity = assignedIdent;
            }
        }

        /// <summary>
        /// If you granted security privileges, then you need to ensure that you revoke the privilege.
        /// </summary>
        public void revokeIdentityPrivileges()
        {
            if (AssignedIdentity != null)
            {
                Aras.Server.Security.Permissions.RevokeIdentity(Aras.Server.Security.Identity.GetByName(AssignedIdentity));
                AssignedIdentity = null;
            }]]></method_code>
  <method_type>C#</method_type>
  <name>acc_sale_bill_approve</name>
 </Item>
</AML>